//*****************************************************************************
//*
//*
//*		GamePriceView.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"GamePrice.h"
#include	"GamePriceDoc.h"
#include	"GamePriceView.h"
#include	"System/ComUtility.h"
#include	"SettingsDlg.h"
#include	<mmsystem.h>
#include	"WinAudio.h"
#include	"MainFrm.h"
#include	<math.h>

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#ifndef 	 DC_PEN
#define		 DC_PEN				19
#endif
#ifndef		 DC_BRUSH
#define 	 DC_BRUSH			18
#endif
#ifndef 	 AC_SRC_ALPHA
#define		 AC_SRC_ALPHA       0x01
#endif
#ifndef		 IDC_HAND
#define		 IDC_HAND			MAKEINTRESOURCE(32649)
#endif

#define 	 UP_TIME			2000					// Zeit in ms fr Balken
#define 	 SWING_TIME			8000					// Zeit in ms frs Nachschwingen
#define 	 SWING_COUNT		5						// Zeit in ms frs Nachschwingen
#define 	 ALPHA				0.7						// Potenz fr Kurve (1=linear 0=Sprung)
#define 	 VEL_END			0.15					// Endgeschwindigkeit in N/s

#define 	 MIN_LEVEL			0.3						// Minmale Balkenhhe (0.0...1.0)
#define 	 TURN_COUNT			5.0						// Umlufe  (bei 100% Balken)
#define 	 TIMER_MS			30						// Zeit fr OnTimer


#define		 PI					3.1415926535897932384626433832795
#define 	 AUDIO_BUFFER		0x0400
#define 	 IDC_UPDATE			0x39AE
#define 	 MAX_POINTS			8
#define 	 FRAME_SIZE			6
#define 	 SLIDER_FRAME		200
#define 	 SLIDER_START		32
#define 	 SLIDER_STEP		100
#define 	 SLIDER_SCALA		60
#define 	 SLIDER_TEXT		50
#define 	 SLIDER_TIME		3200
#define 	 SLIDER_LOOP		1700


#if (_WIN32_WINNT < 0x0500)
extern "C"	 WINGDIAPI COLORREF __stdcall SetDCBrushColor(HDC, COLORREF);
extern "C"	 WINGDIAPI COLORREF __stdcall SetDCPenColor(HDC, COLORREF);
#endif



IMPLEMENT_DYNCREATE(CGamePriceView, CView)

BEGIN_MESSAGE_MAP(CGamePriceView, CView)
	//{{AFX_MSG_MAP(CGamePriceView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_KEYUP()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_KEYDOWN()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_STOP1					,OnStop1)
	ON_COMMAND(ID_STOP2					,OnStop2)
	ON_COMMAND(ID_RESET					,OnReset)
	ON_COMMAND(ID_START					,OnGotoNext)
	ON_COMMAND(ID_SETINGS				,OnSettings)
	ON_COMMAND(ID_NEXTGAME				,OnNextGame)
	ON_COMMAND(ID_STARADD1				,OnStarAdd1)
	ON_COMMAND(ID_STARADD2				,OnStarAdd2)
	ON_COMMAND(ID_STARSUB1				,OnStarSub1)
	ON_COMMAND(ID_STARSUB2				,OnStarSub2)
	ON_COMMAND(ID_USEIMAGE_A			,OnUseImageA)
	ON_COMMAND(ID_USEIMAGE_B			,OnUseImageB)
	ON_COMMAND(ID_USEIMAGE_C			,OnUseImageC)
	ON_COMMAND(ID_USEIMAGE_D			,OnUseImageD)
	ON_COMMAND(ID_SELCOMPORT			,OnSelComPort)
	ON_COMMAND(ID_HTMLFORMAT			,OnHtmlFormat)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_A	,OnUseImageAUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_B	,OnUseImageBUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_C	,OnUseImageCUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_D	,OnUseImageDUI)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


UINT	CGamePriceView::m_uAudioPos;
UINT	CGamePriceView::m_uAudioType;
DWORD	CGamePriceView::m_uLastCling;
UINT	CGamePriceView::m_uCling1Len;
HRSRC	CGamePriceView::m_hCling1Src;
HGLOBAL	CGamePriceView::m_hCling1Hg;
short  *CGamePriceView::m_pCling1;
UINT	CGamePriceView::m_uCling2Len;
HRSRC	CGamePriceView::m_hCling2Src;
HGLOBAL	CGamePriceView::m_hCling2Hg;
short  *CGamePriceView::m_pCling2;
UINT	CGamePriceView::m_uCling3Len;
HRSRC	CGamePriceView::m_hCling3Src;
HGLOBAL	CGamePriceView::m_hCling3Hg;
short  *CGamePriceView::m_pCling3;
UINT	CGamePriceView::m_uErrorLen;
HRSRC	CGamePriceView::m_hErrorSrc;
HGLOBAL	CGamePriceView::m_hErrorHg;
short  *CGamePriceView::m_pError;
UINT	CGamePriceView::m_uTimerLen;
HRSRC	CGamePriceView::m_hTimerSrc;
HGLOBAL	CGamePriceView::m_hTimerHg;
short  *CGamePriceView::m_pTimer;
UINT	CGamePriceView::m_uSweepLen;
HRSRC	CGamePriceView::m_hSweepSrc;
HGLOBAL	CGamePriceView::m_hSweepHg;
short  *CGamePriceView::m_pSweep;
UINT	CGamePriceView::m_uTickLen;
HRSRC	CGamePriceView::m_hTickSrc;
HGLOBAL	CGamePriceView::m_hTickHg;
short  *CGamePriceView::m_pTick;
UINT	CGamePriceView::m_aSndTickStart[MAX_TICKS];
UINT	CGamePriceView::m_aSndTickStop [MAX_TICKS];
UINT	CGamePriceView::m_aSndTickMul  [MAX_TICKS];
UINT	CGamePriceView::m_uSndTickCount;
short  *CGamePriceView::m_aPlay[4];
UINT	CGamePriceView::m_aPlayLen[4];
DWORD	CGamePriceView::m_aHgColors[] =
			{
			BGR(0,0,0),
			BGR(255,0,0),
			BGR(0,200,0),
			BGR(0,0,200),
			};


extern "C"	int ComCheckPort(int iHandle);

BYTE CGamePriceView::m_aSliderFnt[]=
	{
	#include "Image/Fonts/Arial36.h"
	};

BYTE CGamePriceView::m_aScalaFont[]=
	{
	#include "Image/Fonts/Arial24.h"
	};

BYTE CGamePriceView::m_aSliderImg[]=
	{
	#include "Images/Slider.h"
	};

BYTE CGamePriceView::m_aPointerImg[]=
	{
	#include "Images/Pointer.h"
	};


//*****************************************************************************
//*
//*		CGamePriceView
//*
//*****************************************************************************
//  CGamePriceView Konstruktion/Destruktion
CGamePriceView::CGamePriceView()
{
CRegKeys	sKey;


	m_iAudioStop	= 0;
	m_iAudioRun		= 0;
	m_iWndSizeX		= 0;
	m_iWndSizeY		= 0;
	m_uDeltaTick	= 0;
	m_aLockKey[0]	= 0;
	m_aLockKey[1]	= 0;
	m_aPoints [0]	= 0;
	m_aPoints [1]	= 0;
	m_iStop			= 0;
	m_iDone			= 0;
	m_iPort			= 0;
	m_iZoom			= 0;
	m_iImageDrawX	= 0;
	m_iImageDrawY	= 0;
	m_iRotorDrawX	= 0;
	m_iRotorDrawY	= 0;
	m_iDrawAddX		= 0;
	m_iDrawAddY		= 0;
	m_uLastTick		= 0;
	m_iStarSize		= 0;
	m_iStarRows		= 1;
	m_iStarMax		= MAX_POINTS;
	m_iStarX		= 136;
	m_iStarY		= 136;
	m_bHgOk			= 0;
	m_bSingleMode	= 0;									// Jeder startet einzeln
	m_bSameSide		= 0;									// Auf gleicher Seite starten
	m_bAutoCount	= TRUE;									// Automatisch Punkte zhlen
	m_uGameIndex	= 0;									// Aktuelle Spielnummer
	m_uStartTicker	= 0;									// Verzgerter gemeinsamer Start
	m_iStarNum		= -1;									// Wer liegt richtig
	m_uTimeLimith	= 0;									// Zeitlimit in Sekunden
	m_uTimeRest		= 0;									// Rest vom Zeitlimit 

	// REM AZ
	m_dScalaMin		= 100;
	m_dScalaMax		= 800;
	m_dScalaVal		= 600;
	m_dScalaMul		= 1;
	m_bScalaLog		= 0;
	m_iScalaLen		= 1;
	m_iScalaPos		= 0;
	m_iScalaComa	= 0;
	m_dScalaSteps	= 0;
	m_bScalaCol		= TRUE;
	m_bResetFlag	= FALSE;
	m_bStartFlag	= FALSE;

	m_aSliderCol[0]	= BGR(255,0,0);
	m_aSliderCol[1]	= BGR(0,0,255);
	m_aSliderCol[2]	= BGR(0,255,0);
	m_aSliderPos[0]	= 0;
	m_aSliderPos[1]	= 0;
	m_aSliderOld[0]	= -1000;
	m_aSliderOld[1]	= -1000;
	m_aSliderOld[2]	= -1000;
	m_aSliderTxt[0]	= 0;
	m_aSliderTxt[1]	= 0;
	m_aSliderTxt[2]	= 0;
	m_aRunMode[0]	= 0;									// 0=Warten 1=Gestartet 2=Fertig
	m_aRunMode[1]	= 0;									// 0=Warten 1=Gestartet 2=Fertig
	m_aRunMode[2]	= 0;									// 0=Warten 1=Gestartet 2=Fertig
	m_iStarPos		= -1000;								// Sternposition
	m_iStarOld		= -1000;								// Alte Sternposition
	m_bNoGame		= 1;									// Keine Spiele mehr

	sKey.Open();
	sKey.Get(m_iStarSize   ,"StarSize"  );
	sKey.Get(m_uTimeLimith ,"TimeLimith");
	sKey.Get(m_bSingleMode ,"SingleMode");
	sKey.Get(m_bAutoCount  ,"AutoCount" );
	sKey.Get(m_bSameSide   ,"SameSide"  );
	sKey.Get(m_bScalaCol   ,"ScaleColor");
	sKey.Get((int)m_iPort  ,"ComPort"   );
	sKey.Get(m_sHtmlPath   ,"HtmPath"   );

	memset(m_aStars,0xFF,sizeof(m_aStars));
	srand(GetTickCount());

}

//*****************************************************************************
//*
//*		CGamePriceView
//*
//*****************************************************************************
CGamePriceView::~CGamePriceView()
{
CRegKeys	sKey;


	sKey.Open();
	sKey.Set(m_iStarSize  ,"StarSize"  );
	sKey.Set(m_bSingleMode,"SingleMode");
	sKey.Set(m_bAutoCount ,"AutoCount" );
	sKey.Set(m_iPort	  ,"ComPort"   );

	while(!m_iDone)
		{
		m_iStop = 1;
		Sleep(50);
		}

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CGamePriceView::PreCreateWindow(CREATESTRUCT &sCreate)
{

return CView::PreCreateWindow(sCreate);
}


//*****************************************************************************
//*
//*		Draw
//*
//*****************************************************************************
void _cdecl Draw(void *pParam,CDC *pDc,PAINTSTRUCT *pPaint)
{

	pDc->SelectStockObject(BLACK_PEN);
	pDc->SelectStockObject(DKGRAY_BRUSH);
	pDc->Rectangle(10,10,20,20);

}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CGamePriceView::OnCreate(LPCREATESTRUCT pCreateStruct)
{
TCHAR		cHtmlUrl[MAX_PATH];
DWORD		dwThread;
HANDLE		hThread;
CString		sText;
CRect		sRect;
LPBYTE		pData;
UINT		uSize;
UINT		uPos;
UINT		uLen;


	if(CView::OnCreate(pCreateStruct)==-1)
		{
		return -1;
		}

	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)NULL);

	sRect.SetRectEmpty();
	m_cBitmapWnd.Create(WS_CHILD|WS_VISIBLE,sRect,this);
	m_cBitmapWnd.SetBkColor(RGB(0,0,0));

	m_cHtmlWnd.Create(WS_CHILD,CRect(0,0,10,10),&m_cBitmapWnd);

	m_sStarImg1.InsertBitmap(IDB_STAR1);
	m_sStarImg2.InsertBitmap(IDB_STAR2);
	m_sStarImg3.InsertBitmap(IDB_STAR3);

	SelectStar(m_iStarSize);

	hThread = CreateThread(NULL,0x8000,ComThread,this,0,&dwThread);
	CloseHandle(hThread);

	SetTimer(IDC_UPDATE,TIMER_MS,NULL);



	   m_hCling1Src=FindResourceA(NULL,"CLING1","WAVE");
	if(m_hCling1Src)
		{
		m_hCling1Hg	= LoadResource  (NULL,m_hCling1Src);
		uSize		= SizeofResource(NULL,m_hCling1Src);
		pData		= (LPBYTE)LockResource(m_hCling1Hg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pCling1	 = (short*)(pData+uPos);
			m_uCling1Len = uLen/2;
			break;
			}
		}

	   m_hCling2Src=FindResourceA(NULL,"CLING2","WAVE");
	if(m_hCling2Src)
		{
		m_hCling2Hg	= LoadResource  (NULL,m_hCling2Src);
		uSize		= SizeofResource(NULL,m_hCling2Src);
		pData		= (LPBYTE)LockResource(m_hCling2Hg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pCling2	 = (short*)(pData+uPos);
			m_uCling2Len = uLen/2;
			break;
			}
		}

	   m_hCling3Src=FindResourceA(NULL,"CLING3","WAVE");
	if(m_hCling3Src)
		{
		m_hCling3Hg	= LoadResource  (NULL,m_hCling3Src);
		uSize		= SizeofResource(NULL,m_hCling3Src);
		pData		= (LPBYTE)LockResource(m_hCling3Hg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pCling3	 = (short*)(pData+uPos);
			m_uCling3Len = uLen/2;
			break;
			}
		}

	   m_hSweepSrc=FindResourceA(NULL,"SWEEP","WAVE");
	if(m_hSweepSrc)
		{
		m_hSweepHg	= LoadResource  (NULL,m_hSweepSrc);
		uSize		= SizeofResource(NULL,m_hSweepSrc);
		pData		= (LPBYTE)LockResource(m_hSweepHg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pSweep	 = (short*)(pData+uPos);
			m_uSweepLen = uLen/2;
			break;
			}
		}

	   m_hTimerSrc=FindResourceA(NULL,"TIMER","WAVE");
	if(m_hTimerSrc)
		{
		m_hTimerHg	= LoadResource  (NULL,m_hTimerSrc);
		uSize		= SizeofResource(NULL,m_hTimerSrc);
		pData		= (LPBYTE)LockResource(m_hTimerHg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pTimer	 = (short*)(pData+uPos);
			m_uTimerLen = uLen/2;
			break;
			}
		}

	   m_hErrorSrc=FindResourceA(NULL,"ERROR","WAVE");
	if(m_hErrorSrc)
		{
		m_hErrorHg	= LoadResource  (NULL,m_hErrorSrc);
		uSize		= SizeofResource(NULL,m_hErrorSrc);
		pData		= (LPBYTE)LockResource(m_hErrorHg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pError	 = (short*)(pData+uPos);
			m_uErrorLen = uLen/2;
			break;
			}
		}

	   m_hTickSrc=FindResourceA(NULL,"TICK","WAVE");
	if(m_hTickSrc)
		{
		m_hTickHg	= LoadResource  (NULL,m_hTickSrc);
		uSize		= SizeofResource(NULL,m_hTickSrc);
		pData		= (LPBYTE)LockResource(m_hTickHg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pTick	 = (short*)(pData+uPos);
			m_uTickLen = uLen/2;
			break;
			}
		}


	if(m_sHtmlPath.IsEmpty())						// Standardpfad verwenden
		{
		CString		sPath;

		GetExePath(sPath);
		DelBackSlash(sPath);

		#ifdef _DEBUG
		sPath+="\\..\\Release";
		#endif

		sprintf(cHtmlUrl,"%s\\Main\\Info.html",(LPCTSTR)sPath);

		if(ExistFile(cHtmlUrl)==1)
			{
			m_sHtmlPath = sPath;
			}
		}

	if(!m_sHtmlPath.IsEmpty())						// Die Startseite anzeigen
		{
		sprintf(cHtmlUrl,"%s\\Main\\Info.html",(LPCTSTR)m_sHtmlPath);

		if(ExistFile(cHtmlUrl)==1)
			{
			m_cHtmlWnd.Navigate2(cHtmlUrl);
			m_cHtmlWnd.ShowWindow(SW_SHOW);
			m_bNoGame = 0;
			}
		}


	UpdateImage(0,m_aSliderCol[0]);
	UpdateImage(1,m_aSliderCol[1]);
	UpdateImage(2,m_aSliderCol[2]);

	m_iAudioRun	 = 1;
	AudioOpen(44100,16,1,AUDIO_BUFFER);
	hThread = CreateThread(NULL,0x8000,AudioThread,this,0x4000,&dwThread);
	SetThreadPriority(hThread,THREAD_PRIORITY_HIGHEST);
	CloseHandle(hThread);
	AudioPause(0);


return 0;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CGamePriceView::OnDestroy()
{

	AfxGetMainWnd()->ShowWindow(SW_HIDE);
	m_iAudioRun = 0;

	AudioStop();

	while(!m_iAudioStop)
		{
		Sleep(50);
		}

	AudioClose();


	UnlockResource(m_hCling1Hg );
	DeleteObject  (m_hCling1Src);
	UnlockResource(m_hCling2Hg );
	DeleteObject  (m_hCling2Src);
	UnlockResource(m_hTickHg   );
	DeleteObject  (m_hTickSrc  );

	CView::OnDestroy();

}

//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
//  CGamePriceView Zeichnen
void CGamePriceView::OnDraw(CDC *pDC)
{
CGamePriceDoc  *pDoc = GetDocument();


	ASSERT_VALID(pDoc);
}

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
#ifdef		_DEBUG
void CGamePriceView::AssertValid() const
{
	CView::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CGamePriceView::Dump(CDumpContext &dc) const
{
	CView::Dump(dc);
}
#endif

//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
#ifdef		_DEBUG
CGamePriceDoc *CGamePriceView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGamePriceDoc)));

return (CGamePriceDoc*)m_pDocument;
}
#endif

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CGamePriceView::OnSize(UINT nType,int iSizeX,int iSizeY)
{
BitmapImage	   *pImage;
int				iNumX;
int				iNumY;

	if(iSizeX>0 && iSizeY>0)
		{
		pImage			=  m_cBitmapWnd.GetImage();
		pImage->Box(0,0,iSizeX,iSizeY,BGR(0,0,0));
		memset(m_aStars,0xFF,sizeof(m_aStars));
		SizeWindow(&m_cBitmapWnd,iSizeX,iSizeY);

		iNumX			= iSizeX-m_iStarX*2-12;
		iNumY			= iSizeY-SLIDER_FRAME;

		if(iNumX<=0 || iNumY<=0)
			{
			m_cHtmlWnd.ShowWindow(SW_HIDE);
			}
		else{
			m_cHtmlWnd.SetWindowPos(NULL,m_iStarX+6,0,iNumX,iNumY,SWP_NOZORDER|SWP_SHOWWINDOW);
			}

		m_iWndSizeX 	= iSizeX;
		m_iWndSizeY 	= iSizeY;
		m_bHgOk			= 0;
		m_aSliderOld[0]	= -1000;
		m_aSliderOld[1]	= -1000;
		m_aSliderOld[2]	= -1000;
		}

	CView::OnSize(nType,iSizeX,iSizeY);

}

//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
void CGamePriceView::OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint)
{



}

//*****************************************************************************
//*
//*		SetStartPath
//*
//*****************************************************************************
void CGamePriceView::SetStartPath(LPCTSTR pPath)
{
char	cHtmlUrl[MAX_PATH];



	m_sHtmlOrig = m_sHtmlPath;
	m_sHtmlPath = pPath;

	DelBackSlash(m_sHtmlPath);

	sprintf(cHtmlUrl,"%s\\Main\\Info.html",(LPCTSTR)m_sHtmlPath);

	if(ExistFile(cHtmlUrl)==1)
		{
		m_cHtmlWnd.Navigate2(cHtmlUrl);
		m_cHtmlWnd.ShowWindow(SW_SHOW);
		}
	else{
		MessageBox("'.\\Main\\Info.html' wurde im 'Infopfad' nicht gefunden !","Warnung",MB_OK|MB_ICONWARNING);
		}

}


//*****************************************************************************
//*
//*		StartSound
//*
//*****************************************************************************
void CGamePriceView::StartSound(short *pData,unsigned uLen)
{
UINT	uIdx;



	if(!pData || !uLen || uLen>0x40000000)return;


	for(uIdx=0;uIdx<4;uIdx++)
		{
		if(m_aPlayLen[uIdx])continue;

		m_aPlay   [uIdx] = pData;
		m_aPlayLen[uIdx] = uLen;

		break;
		}


}


//*****************************************************************************
//*
//*		AudioThread
//*
//*****************************************************************************
DWORD WINAPI CGamePriceView::AudioThread(LPVOID pParam)
{
CGamePriceView  *pThis=(CGamePriceView*)pParam;
short		   *pWave;
short		   *pData;
unsigned		uStep;
unsigned		uIdx;
unsigned		uOff;
unsigned		uLen;
int				iVal;


	m_uAudioPos = 0;

	while(pThis->m_iAudioRun)
		{
			pData = (short*)AudioWritePtr();
		if(!pData)break;

		uLen = 0;

		if(m_uAudioType==1)									// Sweep-Melodi
			{
			if(m_uAudioPos+AUDIO_BUFFER/2<m_uSweepLen)
				{
				memcpy(pData,m_pSweep+m_uAudioPos,AUDIO_BUFFER);
				m_uAudioPos	   += AUDIO_BUFFER/2;
				uLen			= AUDIO_BUFFER/2;
				}
			else{
				uLen			= m_uSweepLen-m_uAudioPos;
				memcpy(pData,m_pSweep+m_uAudioPos,uLen*2);
				m_uAudioType	= 0;
				m_uAudioPos		= 0;
				}
			}
		else if(m_uAudioType==2)							// Ticker
			{
			for(uOff=0;uOff<AUDIO_BUFFER/2;uOff++)
				{
				iVal = 0;

				for(uIdx=m_uSndTickCount;uIdx;)
					{
					uIdx--;
					if(m_aSndTickStart[uIdx]>m_uAudioPos)continue;
					if(m_aSndTickStop [uIdx]<m_uAudioPos)continue;

					uStep  = (m_uAudioPos-m_aSndTickStart[uIdx])*256*128;
					uStep /=  m_aSndTickMul[uIdx];

					if(uStep+1>=m_uTickLen*128)continue;

					iVal  += (m_pTick[uStep/128  ])*(128-uStep%128);
					iVal  += (m_pTick[uStep/128+1])*(    uStep%128);
					}

				iVal /= 128;

				if(iVal> 0x7FFF)iVal= 0x7FFF;
				if(iVal<-0x7FFF)iVal=-0x7FFF;

				pData[uOff] = iVal;
				m_uAudioPos++;
				}

			uLen = uOff;
			}

		for(uOff=0;uOff<uLen;uOff++)						// Lautstrke verringern
			{
			pData[uOff] /= 8;
			}

		for(;uOff<AUDIO_BUFFER/2;uOff++)					// Den Rest stummschalten
			{
			pData[uOff]  = 0;
			}

		for(uIdx=0;uIdx<4;uIdx++)							// Weitere Thne hinzu mischen
			{
			if(!m_aPlayLen[uIdx])continue;

			uLen  = m_aPlayLen[uIdx];
			pWave = m_aPlay   [uIdx];

			for(uOff=0;uOff<AUDIO_BUFFER/2;uOff++)
				{
				if(uOff>=uLen)break;

				iVal  = pData[uOff];
				iVal += pWave[uOff];

				if(iVal> 0x7FFF)iVal= 0x7FFF;
				if(iVal<-0x7FFF)iVal=-0x7FFF;

				pData[uOff] = iVal;
				}

			m_aPlayLen[uIdx] -= uOff;
			m_aPlay   [uIdx] += uOff;
			}

		AudioWrite(AUDIO_BUFFER);
		}


	pThis->m_iAudioStop = 1;


return 1;
}

//*****************************************************************************
//*
//*		StartSound
//*
//*****************************************************************************
void CGamePriceView::StartSound(LPCTSTR pSound)
{
DWORD		dwThread;
HANDLE		hThread;


	hThread = CreateThread(NULL,0x8000,WaveThread,(void*)pSound,0x1000,&dwThread);
	CloseHandle(hThread);

}

//*****************************************************************************
//*
//*		WaveThread
//*
//*****************************************************************************
DWORD WINAPI CGamePriceView::WaveThread(LPVOID pParam)
{
LPCTSTR		pName=(LPCTSTR)pParam;
unsigned	uDiff;
unsigned	uTick;


	if(!strncmp(pName,"CLING",5))
		{
		uTick	= GetTickCount();
		uDiff	= uTick-m_uLastCling;
		if(uDiff<280)Sleep(280-uDiff);
		m_uLastCling = GetTickCount();
		}

return PlaySound(pName,AfxGetInstanceHandle(),SND_RESOURCE|SND_ASYNC);
}

//*****************************************************************************
//*
//*		OnUseImage?UI
//*
//*****************************************************************************
void CGamePriceView::OnUseImageAUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==2);}
void CGamePriceView::OnUseImageBUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==1);}
void CGamePriceView::OnUseImageCUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==0);}
void CGamePriceView::OnUseImageDUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==3);}

//*****************************************************************************
//*
//*		OnSelComPort
//*
//*****************************************************************************
void CGamePriceView::OnSelComPort()
{
char		cText[32];
int			iPort;
CTextDlg	sDlg;


	sprintf(cText,"COM%i",m_iPort+1);

	sDlg.SetText(cText);
	sDlg.SetTitle("COM-Port");
	sDlg.SetTextTitle("Bitte hier das COM-Port angeben :");
	if(sDlg.DoModal()!=IDOK)return;

	sDlg.GetText(cText,sizeof(cText));

	if(memicmp(cText,"COM",3))
		{
		iPort = strtoi(cText);
		}
	else{
		iPort = strtoi(cText+3);
		}

	m_iPort = (iPort<=0)? 0:iPort-1;

}

//*****************************************************************************
//*
//*		OnReset
//*
//*****************************************************************************
void CGamePriceView::OnReset()
{

	m_bStartFlag = FALSE;
	m_bResetFlag = TRUE;
	Reset();

}


//*****************************************************************************
//*
//*		OnStart
//*
//*****************************************************************************
//	Direkt starten
void CGamePriceView::OnStart()
{
unsigned	uTime;


	if(m_bSingleMode==0)return;								// Einzeln starten
	if(m_bNoGame)return;

	if(m_aRunMode[0])return;
	if(m_aRunMode[1])return;

	uTime = GetTickCount();

	m_aRunMode  [0]	= 1;
	m_aRunMode  [1]	= 1;
	m_aStartTick[0]	= uTime;
	m_aStartTick[1]	= uTime;

}

//*****************************************************************************
//*
//*		Start
//*
//*****************************************************************************
void CGamePriceView::Start(unsigned uPlace,unsigned uTick)
{

	if(uPlace>=2)
		{
		return;
		}

	if(m_bNoGame)											// Keine Spiele mehr
		{
		return;
		}

	if(m_bSingleMode)										// Wird gemeisam gestartet
		{
		return;
		}

	if(m_aRunMode[uPlace]!=0)								// Bereits gestartet
		{
		return;
		}

	if(m_uGameIndex<=0)										// Noch kein Spiel aktiv
		{
		return;
		}
	
	m_aRunMode  [uPlace]	= 1;
	m_aStartTick[uPlace]	= uTick;


}

//*****************************************************************************
//*
//*		Stop
//*
//*****************************************************************************
void CGamePriceView::Stop(unsigned uPlace,unsigned uTick)
{


	if(uPlace>=2)return;

	if(m_aRunMode[uPlace]!=1)								// Nicht gestartet
		{
		return;
		}

	m_aRunMode [uPlace]	= 2;
	m_aStopTick[uPlace]	= uTick;

	if(uPlace)StartSound(m_pCling2,m_uCling2Len);
	else      StartSound(m_pCling1,m_uCling1Len);

	m_uAudioType	= 2;
	m_uAudioPos		= 0;



}

//*****************************************************************************
//*
//*		Reset
//*
//*****************************************************************************
//	Hllt den Zeiger aprupt an
void CGamePriceView::Reset()
{

	m_iStarPos		= -1000;
	m_iStarNum		= -1;
	m_aRunMode [0]	= 0;
	m_aRunMode [1]	= 0;
	m_aRunMode [2]	= 0;
	m_uStartTicker	= 0;
	m_bHgOk			= 0;

	m_uAudioPos		= 0;
	m_uAudioType	= 0;

}

//*****************************************************************************
//*
//*		SetZoom
//*
//*****************************************************************************
void CGamePriceView::SetZoom(int iZoom)
{

	m_iZoom = iZoom;

	GetWindowRect(&m_sWndRect);
	m_sWndRect.right--;

}

//*****************************************************************************
//*
//*		OnStarAdd1
//*
//*****************************************************************************
void CGamePriceView::OnStarAdd1()
{
	m_aPoints[0] = (m_aPoints[0]+1)%m_iStarMax;
}

//*****************************************************************************
//*
//*		OnStarAdd2
//*
//*****************************************************************************
void CGamePriceView::OnStarAdd2()
{
	m_aPoints[1] = (m_aPoints[1]+1)%m_iStarMax;
}

//*****************************************************************************
//*
//*		OnStarSub1
//*
//*****************************************************************************
void CGamePriceView::OnStarSub1()
{
	m_aPoints[0] = (m_aPoints[0]+m_iStarMax-1)%m_iStarMax;
}

//*****************************************************************************
//*
//*		OnStarSub2
//*
//*****************************************************************************
void CGamePriceView::OnStarSub2()
{
	m_aPoints[1] = (m_aPoints[1]+m_iStarMax-1)%m_iStarMax;
}


//*****************************************************************************
//*
//*		ScaleColor
//*
//*****************************************************************************
//	Farbe fr Skala
//	iPos	: Position in der Scala
//	iMax	: Lnge der Scala
UINT CGamePriceView::ScaleColor(int iPos,int iMax)
{
int		iVal;
int		iNum;
int		iCol;

	iNum = (511*iPos)/iMax;

	if(iNum<  0)iNum=0;
	if(iNum>511)iNum=511;

	if(iNum<256)
		{
		iVal = iNum/4+192;
		iCol = BGR(255-iNum,iVal,0);
		}
	else{
		iNum = 511-iNum;
		iVal = iNum/4+192;
		iCol = BGR(0,iVal,255-iNum);
		}


return iCol;
}


//*****************************************************************************
//*
//*		ValueText
//*
//*****************************************************************************
UINT CGamePriceView::ValueText(char *pText,double dVal,int iComa)
{
int		iNum;
int		iPos;



	iNum = sprintf(pText,"%i",(int)dVal);	

	if(iComa)
		{
		if(iNum<=iComa)
			{
			memmove(pText+iComa+1-iNum,pText,iNum+1);
			memset (pText,'0',iComa+1-iNum);
			iNum = iComa+1;
			}

		memmove(pText+iNum-iComa+1,pText+iNum-iComa,iComa+1);
		pText[iNum-iComa] = '.';
		iNum++;
		}

	iPos = iNum-iComa-3;

	for(;iPos>0;iPos-=3)						// Tausender Trennzeichen
		{
		memmove(pText+iPos+1,pText+iPos,iNum-iPos+1);
		pText[iPos]=' ';
		}

	if(iComa)
		{
		while(iNum>0 && pText[iNum-1]=='0')
			{
			iNum--;
			pText[iNum]=0;
			}

		if(iNum>0 && pText[iNum-1]=='.')
			{
			iNum--;
			pText[iNum]=0;
			}
		}

return iNum;
}

//*****************************************************************************
//*
//*		ComThread
//*
//*****************************************************************************
DWORD WINAPI CGamePriceView::ComThread(LPVOID pParam)
{
CGamePriceView *pThis=(CGamePriceView*)pParam;
char			aData[33];
static int		aLastPush[8];
static int		aLastPop [8];
int				iHandle=-1;
int				iValue;
int				iFlag;
int				iPort;
int				iDiff;
int				iPin;
int				iPos;
int				iOff;


	iPort = -1;
	iPos  =  0;

	while(!pThis->m_iStop)
		{
		if(iPort!=pThis->m_iPort || !ComCheckPort(iHandle))
			{
			ComClose(iHandle);
			iPort   = pThis->m_iPort;
			iHandle = ComOpen(iPort,9600);
			}

		if(iHandle<0)
			{
			Sleep(200);
			continue;
			}

		for(iOff=0;iOff<iPos;iOff++)
			{
			if(!strwchar(aData[iOff],0x00040001))
				{
				continue;
				}

			if(iOff+1<iPos)
				{
				if(aData[iOff+1]!='U')
				if(aData[iOff+1]!='S')
				if(aData[iOff+1]!='D')continue;
				}

			break;
			}

		if(iOff>0)
			{
			iPos -= iOff;
			memmove(aData,aData+iOff,iPos);
			}

		aData[iPos] = 0;
		iFlag		= 0;

		while(iPos>=3)
			{
			iOff = strwlen(aData+2,0x00040001);

			if(iOff>8)
				{
				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}


			if(iOff<8)
				{
				if(iOff+2==iPos)break;

				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}

			if(iOff==8 && iPos==10)
				{
				break;
				}

			if(iOff==8 && aData[10]!='\r' && aData[10]!='\n')
				{
				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}

			iPin	= aData[0]-'0';
			iValue	= strtoh(aData+2);

			if(aData[1]=='S' && iPin<=3)				// Synchronisierung empfangen
				{
				pThis->m_uDeltaTick = GetTickCount()-iValue;
				}
			else if(!pThis->m_uDeltaTick)				// Noch keine Synchronisierung
				{
				pThis->m_uDeltaTick = GetTickCount()-iValue;
				}

			iValue += pThis->m_uDeltaTick;

			if(aData[1]=='D' && iPin<2)					// Buzzer loslassen
				{
				   iDiff = iValue-aLastPop[iPin];
				if(iDiff<0 || iDiff>100)
					{
					aLastPop[iPin] = iValue;

					switch(iPin)
						{
					case 0:	pThis->Stop(0,iValue);
							break;

					case 1:	pThis->Stop(1,iValue);
							break;
						}
					}
				}

			if(aData[1]=='D' && iPin<8)					// Taste gedrckt
				{
				   iDiff = iValue-aLastPush[iPin];
				if(iDiff<0 || iDiff>100)
					{
					aLastPush[iPin] = iValue;

					switch(iPin)
						{
					case 0:	if(pThis->m_bSingleMode)
									pThis->Stop (0,iValue);
							else	pThis->Start(0,iValue);
							break;

					case 1:	if(pThis->m_bSingleMode)
									pThis->Stop (1,iValue);
							else	pThis->Start(1,iValue);
							break;

					case 2:	pThis->PostMessage(WM_COMMAND,ID_START);
							break;

					case 3:	pThis->PostMessage(WM_COMMAND,ID_RESET);
							break;

					case 4:	pThis->PostMessage(WM_COMMAND,ID_STARSUB1);
							break;

					case 5:	pThis->PostMessage(WM_COMMAND,ID_STARADD1);
							break;

					case 6:	pThis->PostMessage(WM_COMMAND,ID_STARSUB2);
							break;

					case 7:	pThis->PostMessage(WM_COMMAND,ID_STARADD2);
							break;
						}
					}
				}

			if(aData[11]!='\n')iOff++;

			iOff += 2;
			iPos -= iOff;

			if(iPos<0 || iPos>32)iPos=0;

			memmove(aData,aData+iOff,iPos);

			if(iPos>=3)
				{
				if(aData[0]<'0'){iFlag=1;break;}
				if(aData[0]>'7'){iFlag=1;break;}
				if(aData[iOff+1]!='U')
				if(aData[iOff+1]!='S')
				if(aData[iOff+1]!='D'){iFlag=1;break;}
				}
			}

		if(iFlag)continue;


		ComWaitUntilResv(iHandle,100);
		iOff = ComGetReadCount(iHandle);
		if(iOff<=0)
			{
			if(iOff==0)continue;
			iPort=-1;
			continue;
			}

		if(iPos+iOff>32)iOff=32-iPos;
		iOff = ComRead(iHandle,aData+iPos,iOff);
		if(iOff<=0)
			{
			if(iOff==0)continue;
			iPort=-1;
			continue;
			}

		iPos += iOff;
		aData[iPos] =0;
		}


	ComClose(iHandle);
	pThis->m_iDone = 1;


return 0;
}

//*****************************************************************************
//*
//*		OnUseImage?
//*
//*****************************************************************************
void CGamePriceView::OnUseImageA(){UseImage(2);}
void CGamePriceView::OnUseImageB(){UseImage(1);}
void CGamePriceView::OnUseImageC(){UseImage(0);}
void CGamePriceView::OnUseImageD(){UseImage(3);}


//*****************************************************************************
//*
//*		UseImage
//*
//*****************************************************************************
//	Eine neue Gre der Sterne einstellen
//	iMode		: Gre der Sterne (0=gro 1=mittel 2=klein 3=Zwei-Reihen)
void CGamePriceView::UseImage(int iMode)
{
BOOL	bFlag=0;

	if(m_iStarSize!=iMode)
		{
		bFlag		= 1;
		m_bHgOk		= 0;
		m_iStarSize = iMode;
		}

	SelectStar(m_iStarSize);

	memset(m_aStars,0xFF,sizeof(m_aStars));

	m_cBitmapWnd.RedrawWindow();

	if(bFlag)
		{
		OnSize(0,m_iWndSizeX,m_iWndSizeY);
		}

}

//*****************************************************************************
//*
//*		SelectStar
//*
//*****************************************************************************
//	Eine neue Gre der Sterne einstellen
//	iStar		: Gre der Sterne (0=gro 1=mittel 2=klein 3=Zwei-Reihen)
void CGamePriceView::SelectStar(int iStar)
{

	switch(iStar)
		{
	case 3:	m_sStarImg		= m_sStarImg3;
			m_iStarMax		= MAX_POINTS*3+(MAX_POINTS+1&1);
			m_iStarX		= 136;
			m_iStarY		= 68;
			m_iStarRows		= 2;
			break;

	case 2:	m_sStarImg		= m_sStarImg3;
			m_iStarMax		= MAX_POINTS;
			m_iStarX		= 68;
			m_iStarY		= 68;
			m_iStarRows		= 1;
			break;

	case 1:	m_sStarImg		= m_sStarImg2;
			m_iStarMax		= MAX_POINTS;
			m_iStarX		= 102;
			m_iStarY		= 102;
			m_iStarRows		= 1;
			break;

	default:m_sStarImg		= m_sStarImg1;
			m_iStarMax		= MAX_POINTS;
			m_iStarX		= 136;
			m_iStarY		= 136;
			m_iStarRows		= 1;
			break;
		}

}

//*****************************************************************************
//*
//*		OnStop1
//*
//*****************************************************************************
void CGamePriceView::OnStop1()
{
	OnKeyDown(VK_F7,1,0);
}

//*****************************************************************************
//*
//*		OnStop2
//*
//*****************************************************************************
void CGamePriceView::OnStop2()
{
	OnKeyDown(VK_F8,1,0);
}

//*****************************************************************************
//*
//*		OnKeyDown
//*
//*****************************************************************************
void CGamePriceView::OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags)
{
unsigned	uTime;
unsigned	uDiff;


	switch(nChar)
		{
	case VK_F7:	uTime = GetTickCount();
				if(m_aLockKey[0])
					{
					   uDiff = uTime-m_aLockKey[0];
					if(uDiff<8000)break;
					}
				m_aLockKey[0] = uTime;

				if(m_bSingleMode)
						Stop (0,uTime);
				else	Start(0,uTime);
				break;

	case VK_F8:	uTime = GetTickCount();
				if(m_aLockKey[1])
					{
					   uDiff = uTime-m_aLockKey[1];
					if(uDiff<8000)break;
					}
				m_aLockKey[1] = uTime;

				if(m_bSingleMode)
						Stop (1,uTime);
				else	Start(1,uTime);
				break;
		}

	CView::OnKeyDown(nChar,nRepCnt,nFlags);
}


//*****************************************************************************
//*
//*		OnKeyUp
//*
//*****************************************************************************
void CGamePriceView::OnKeyUp(UINT nChar,UINT nRepCnt,UINT nFlags)
{

	switch(nChar)
		{
	case VK_F7:	m_aLockKey[0] = 0;
				Stop(0,GetTickCount());
				break;
	case VK_F8:	m_aLockKey[1] = 0;
				Stop(1,GetTickCount());
				break;
		}

	CView::OnKeyUp(nChar,nRepCnt,nFlags);
}


//*****************************************************************************
//*
//*		OnSettings
//*
//*****************************************************************************
void CGamePriceView::OnSettings()
{
CSettingsDlg	sDlg;
CRegKeys		sKey;


	if(m_uTimeLimith>60)m_uTimeLimith=60;

	sDlg.m_sHtmlPath	= m_sHtmlPath;
	sDlg.m_iTimeLimith	= m_uTimeLimith;
	sDlg.m_bSingleMode	= m_bSingleMode;
	sDlg.m_bAutoCount	= m_bAutoCount;
	sDlg.m_bSameSide	= m_bSameSide;
	sDlg.m_bScalaCol	= m_bScalaCol;

	if(!m_sHtmlOrig.IsEmpty())									// Wurde Pfad ber Kommandozeile gesetzt
		{
		sDlg.m_sHtmlPath = m_sHtmlOrig;
		}


	if(sDlg.DoModal()!=IDOK)return;

	m_sHtmlOrig.Empty();

	if(m_bScalaCol!=sDlg.m_bScalaCol)m_bHgOk=FALSE;
	if(m_sHtmlPath!=sDlg.m_sHtmlPath)
		{
		PostMessage(WM_COMMAND,ID_START);
		m_uGameIndex = 0;
		}

	m_sHtmlPath			= sDlg.m_sHtmlPath;
	m_uTimeLimith		= sDlg.m_iTimeLimith;
	m_bSingleMode		= sDlg.m_bSingleMode;
	m_bAutoCount		= sDlg.m_bAutoCount;
	m_bSameSide			= sDlg.m_bSameSide;
	m_bScalaCol			= sDlg.m_bScalaCol;

	sKey.Open();
	sKey.Set(m_iStarSize  ,"StarSize"  );
	sKey.Set(m_uTimeLimith,"TimeLimith");
	sKey.Set(m_bSingleMode,"SingleMode");
	sKey.Set(m_bAutoCount ,"AutoCount" );
	sKey.Set(m_bSameSide  ,"SameSide"  );
	sKey.Set(m_bScalaCol  ,"ScaleColor");
	sKey.Set(m_sHtmlPath  ,"HtmPath"   );


}

//*****************************************************************************
//*
//*		UpdateImage
//*
//*****************************************************************************
void CGamePriceView::UpdateImage(UINT uNumber,COLORREF uColor)
{
static COLORREF		aLast[2];
BITMAPINFOHEADER   *pInfo;
BitmapImage		   *pPic;
DWORD				uPos;
LPBYTE				pPixel;
LPBYTE				pInput;
LPBYTE				pImage;
unsigned			uGrey;
unsigned			uSize;
unsigned			uColR;
unsigned			uColG;
unsigned			uColB;



	if(uNumber>=3)return;

	if(aLast[uNumber]==uColor)return;

	if(uNumber==2)
		{
		pInput 	= m_aPointerImg;
		uSize  	= sizeof(m_aPointerImg);
		}
	else{
		pInput 	= m_aSliderImg;
		uSize  	= sizeof(m_aSliderImg);
		}

	pPic	= m_aSlider+uNumber;


	pInfo	= (BITMAPINFOHEADER*)pInput;
	pImage	= pInput+sizeof(BITMAPINFOHEADER);
	uPos	= uSize -sizeof(BITMAPINFOHEADER);

	pPic->SetSize(32,pInfo->biWidth,pInfo->biHeight,BI_NOT_INIT);
	pPixel 	= pPic->ImageData();

	uColB	= (uColor>>16)&0xFF;
	uColG	= (uColor>> 8)&0xFF;
	uColR	= (uColor>> 0)&0xFF;

 	ASSERT(pInfo->biBitCount==32);

	if(uNumber==2)
		{
		memcpy(pPixel,pImage,uPos);
		return;
		}


	while(uPos>0)										// Farbe anpassen
		{
		uPos -= 4;
		uGrey = pImage[uPos+1];

		if(uGrey+pImage[uPos+2]>255)
			{
			uGrey = 255-pImage[uPos+2];
			}

		pPixel[uPos  ]  = uGrey;
		pPixel[uPos+1]  = uGrey;
		pPixel[uPos+2]  = uGrey;
		pPixel[uPos+3]  = pImage[uPos+3];
		pPixel[uPos  ] +=(pImage[uPos+2]*uColR)/255;
		pPixel[uPos+1] +=(pImage[uPos+2]*uColG)/255;
		pPixel[uPos+2] +=(pImage[uPos+2]*uColB)/255;
		}

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CGamePriceView::OnTimer(UINT_PTR nIdEvent)
{
static BOOL		bLocked=0;
char			cText[92];
BitmapImage	   *pImage;
DWORD			uColor;
DWORD			uTick;
DWORD			uDiff;
CPoint			sPoint;
int				iBottom;
int				iSizeX;
int				iSizeY;
int				iOffX;
int				iOffY;
int				iEndY;
int				iAddX;
int				iAddY;
int				iPicX;
int				iPicY;
int				iSide;
int				iComa;
int				iPos;
int				iMin;
int				iMax;
int				iNum;
int				iVal;
int				iRow;
int				iBit;
int				iNew;



	if(nIdEvent==IDC_UPDATE)
		{
		if(!m_iWndSizeX || !m_iWndSizeY)
			{
			return;
			}

		if(bLocked)return;

		bLocked = TRUE;

		if(m_iZoom==2)										// Cursor weg schieben bei Zoom
			{
			GetCursorPos(&sPoint);

			if(m_sWndRect.PtInRect(sPoint))
				{
				SetCursorPos(m_sWndRect.right,m_sWndRect.bottom-1);
				}
			}

		iMin	= 0;
		iMax	= 0;
		iNew	= 0;
		uTick	= GetTickCount();
		pImage	= m_cBitmapWnd.GetImage();
		iBottom	= m_iWndSizeY-SLIDER_FRAME;
		if(iBottom<0)iBottom=0;


		if(m_uTimeRest && m_uTimeLimith)					// Ist ein Zeitlimit eingestellt
			{
			m_uTimeRest--;

			if(m_uTimeRest==0)
				{
				if(m_aRunMode[0]==0)Start(0,uTick);
				if(m_aRunMode[1]==0)Start(1,uTick);
				if(m_aRunMode[0]==1)Stop (0,uTick);
				if(m_aRunMode[1]==1)Stop (1,uTick);
				}
			else if(m_uTimeRest%(1000/TIMER_MS)==0 && m_uTimeRest<=(1000/TIMER_MS)*5)
				{
				if(m_aRunMode[0]!=2 || m_aRunMode[1]!=2)	// Slider noch nicht fertig
					{
					StartSound(m_pTimer,m_uTimerLen);
					}
				}
			}



		for(iSide=0;iSide<2;iSide++)						// Seitlicher Balken abarbeiten
			{
			for(iPos=0,iOffY=0;iPos<16*m_iStarRows;iPos++)	// Sterne im seitlichen Balken prfen
				{
				if(iOffY>=iBottom)break;

				iEndY = iOffY+m_iStarY;

				   iNum = (m_aPoints[iSide]<=(UINT)iPos)? 0:1;
				if(iNum!=m_aStars[iPos*2+iSide])
					{
					if(iMax==iMin)
						{
						iMin = iOffY;
						iMax = iEndY;
						}
					else{
						if(iMin>iOffY)iMin=iOffY;
						if(iMax<iEndY)iMax=iEndY;
						}
					}

				   iRow = iPos%m_iStarRows;
				if(iRow+1>=m_iStarRows)
					{
					iOffY  = iEndY;
					}
				}

			if(iMin!=iMax)									// Gibt es nderungen im Balken
				{
				iOffX = (iSide)? m_iWndSizeX-m_iStarX:0;
				iPicX = m_iStarX/m_iStarRows;
				iPicY = m_iStarY;

				for(iPos=0,iOffY=0;iPos<16*m_iStarRows;iPos++)
					{
					if(iOffY>=iBottom)break;

					iEndY = iOffY+m_iStarY;

					if(iOffY<iMax || iEndY>iMin)
						{
						pImage->Box(iOffX,iBottom-iEndY,iPicX,iPicY,m_aHgColors[0]);
						iNum = (m_aPoints[iSide]<=(UINT)iPos)? 0:1;
						m_aStars[iPos*2+iSide] = iNum;

						if(iNum)							// Keinen Stern zeichnen
							{
							iAddX = (iPicX-m_sStarImg.Width ())/2;
							iAddY = (iPicY-m_sStarImg.Height())/2;
							pImage->PutAlpha(m_sStarImg,iOffX+iAddX,iBottom-iEndY+iAddY);
							}
						}

					   iRow = iPos%m_iStarRows;
					if(iRow+1>=m_iStarRows)
						{
						iOffX -= iPicX*(m_iStarRows-1);
						iOffY  = iEndY;
						}
					else{
						iOffX += iPicX*(m_iStarRows-1);
						}
					}


				if(iOffY<iMax)								// Bereich ber den Sternen
					{
					pImage->Box(iOffX,iBottom-iAddY-1,m_iStarX,iAddY-iMax,0);
					}

				m_cBitmapWnd.InvalidateRect(iOffX,iBottom-iMax,m_iStarX,iMax-iMin);
				}
			}

		if(m_uStartTicker)									// Verzgerter gemeinsamer Start
			{
				m_uStartTicker--;
			if(!m_uStartTicker)OnStart();
			}


		if(!m_bHgOk)										// Rahmen zeichnen
			{
			pImage->Box(m_iStarX+0,0,1,iBottom,BGR(222,222,222));
			pImage->Box(m_iStarX+1,0,1,iBottom,BGR(188,188,188));
			pImage->Box(m_iStarX+2,0,2,iBottom,BGR(133,133,133));
			pImage->Box(m_iStarX+4,0,1,iBottom,BGR( 88, 88, 88));
			pImage->Box(m_iStarX+5,0,1,iBottom,BGR( 44, 44, 44));

			m_cBitmapWnd.InvalidateRect(m_iStarX,0,6,iBottom);

			pImage->Box(m_iWndSizeX-6-m_iStarX+0,0,1,iBottom,BGR(222,222,222));
			pImage->Box(m_iWndSizeX-6-m_iStarX+1,0,1,iBottom,BGR(188,188,188));
			pImage->Box(m_iWndSizeX-6-m_iStarX+2,0,2,iBottom,BGR(133,133,133));
			pImage->Box(m_iWndSizeX-6-m_iStarX+4,0,1,iBottom,BGR( 88, 88, 88));
			pImage->Box(m_iWndSizeX-6-m_iStarX+5,0,1,iBottom,BGR( 44, 44, 44));

			m_cBitmapWnd.InvalidateRect(m_iWndSizeX-6-m_iStarX,0,6,iBottom);

			pImage->Box(0,iBottom+0,m_iWndSizeX,1,BGR(222,222,222));
			pImage->Box(0,iBottom+1,m_iWndSizeX,1,BGR(188,188,188));
			pImage->Box(0,iBottom+2,m_iWndSizeX,2,BGR(133,133,133));
			pImage->Box(0,iBottom+4,m_iWndSizeX,1,BGR( 88, 88, 88));
			pImage->Box(0,iBottom+5,m_iWndSizeX,1,BGR( 44, 44, 44));
			pImage->Box(0,iBottom+6,m_iWndSizeX,m_iWndSizeY-iBottom,0);

			m_cBitmapWnd.InvalidateRect(0,iBottom,m_iWndSizeX,m_iWndSizeY-iBottom);
			}


		if(!m_bHgOk)										// Skala zeichnen
			{
			double	dScale;
			double	dDelta;
			double	dStep;
			double	dRest;
			double	dFull;
			double	dLog;
			double	dVal;
			double	dMin;
			double	dMax;

			   m_iScalaLen	=  m_iWndSizeX-SLIDER_START*2;
			if(m_iScalaLen<=0)m_iScalaLen=1;

			m_iScalaPos = SLIDER_START;

			if(m_bScalaCol)									// Skala mehrfarbig
				{
				for(iVal=-1;iVal<=m_iScalaLen;iVal++)
					{
					pImage->Box(m_iScalaPos+iVal,iBottom+SLIDER_SCALA,1,-2,ScaleColor(iVal,m_iScalaLen));
					}
				}
			else{
				pImage->Box(m_iScalaPos-1,iBottom+SLIDER_SCALA,m_iScalaLen+2,-2,BGR(0,255,0));
				}

			if(m_bScalaLog)
				{
				if(m_dScalaMin<0.00001)m_dScalaMin=m_dScalaMax/20.0;
				if(m_dScalaMin<0.00001)m_dScalaMin=0.00001;
				if(m_dScalaMax<0.00002)m_dScalaMax=0.00002;
				}

			dMin = m_dScalaMin;
			dMax = m_dScalaMax;

			for(iComa=0;iComa<6;iComa++)					// Kommastellen berechnen
				{
				if(fabs(dMax)>=100.0)break;

				dMin *= 10.0;
				dMax *= 10.0;
				}

			if(m_bScalaLog)									// Logarithmisch
				{
				dMin = log10(dMin);
				dMax = log10(dMax);
				}

			iVal	= m_iScalaLen/SLIDER_STEP;
			dDelta	= dMax-dMin;
			dStep	= dDelta/(double)iVal;
			dScale 	= (double)m_iScalaLen/dDelta;
			dLog	= log10(dStep);
			dRest	= modf(dLog,&dFull);
			if(dRest<0.0)dFull-=1.0;

			dStep  /= pow (10.0,dFull);

				 if(dStep<=2.5)dStep= 2.5;
			else if(dStep<=5.0)dStep= 5.0;
			else			   dStep=10.0;


			dStep  *= pow (10.0,dFull);
			iVal	= (int)((dMin+dStep*0.995)/dStep);
			dVal	= dStep*(double)iVal;
			iBit	= iVal&1;

			pImage->SetAlign(1);
			pImage->SetFont(m_aScalaFont);
			pImage->SetPixelFunction(TEXT_NONE,0,1);
			pImage->SetPixelFunction(TEXT_SMOTH,BGR(0,255,0),0);

			for(;;dVal+=dStep,iBit++)						// Skala zeichnen
				{
				iVal = (int)((dVal-dMin)*dScale);

				if(iVal>m_iScalaLen)break;

				uColor = (m_bScalaCol)? ScaleColor(iVal,m_iScalaLen):BGR(0,255,0);

				iVal  += m_iScalaPos;
				pImage->Box(iVal-1,iBottom+SLIDER_SCALA-2,2,(iBit&1)? -6:-12,uColor);

				if(iBit&1)continue;
				if(m_bNoGame)continue;

				iNum = ValueText(cText,(m_bScalaLog)? pow(10.0,dVal):dVal,iComa);
				iNum = pImage->Print(0,BI_TETXSIZE,cText);
					   pImage->SetPixelFunction(TEXT_SMOTH,uColor,0);

				if(iVal<iNum/2-2)
						pImage->Print(2+iNum/2,iBottom+SLIDER_SCALA-48,cText);
				else if(iVal+iNum/2+2>m_iWndSizeX)
						pImage->Print(m_iWndSizeX-iNum/2-2,iBottom+SLIDER_SCALA-48,cText);
				else	pImage->Print(iVal,iBottom+SLIDER_SCALA-48,cText);
				}

			m_cBitmapWnd.InvalidateRect(0,iBottom+6,m_iWndSizeX,SLIDER_SCALA);
			m_dScalaSteps	= dScale;
			m_iScalaComa	= iComa;
			m_dScalaMul		= pow(10.0,iComa);
			}


		for(iSide=0;iSide<2;iSide++)						// Slider-Position berechnen
			{
			if(m_aRunMode[iSide]==0)
				{
				if(!m_bSameSide && iSide)
					{
					m_aSliderPos[iSide]	= m_iScalaLen;
					continue;
					}

				m_aSliderPos[iSide] = 0;
				continue;
				}

			if(m_aRunMode[iSide]==1)
					uDiff = uTick             -m_aStartTick[iSide];
			else	uDiff = m_aStopTick[iSide]-m_aStartTick[iSide];

			iBit  = uDiff/SLIDER_TIME;
			uDiff = uDiff%SLIDER_TIME;

			if(!m_bSameSide && iSide)
				{
				iBit ^= 1;
				}

			m_aSliderPos[iSide] = (m_iScalaLen*uDiff)/SLIDER_TIME;

			if(iBit&1)
				{
				m_aSliderPos[iSide] = m_iScalaLen-m_aSliderPos[iSide];
				}
			}

		iBit = (m_bHgOk)? 0:1;

		if(m_aRunMode[0]==2 && m_aRunMode[1]==2)			// Beide Slider fertig
			{
			double	dVal;
			double	dMul;

			if(m_aRunMode[2]==0)
				{
				m_bResetFlag	= 0;
				m_aRunMode  [2] = 1;
				m_aStartTick[2] = uTick;
				m_uSliderLoops	= 3+rand()%6;

				if(m_bScalaLog)
					{
					dVal    = log10(m_dScalaVal/m_dScalaMul);
					dVal   -= log10(m_dScalaMin/m_dScalaMul);
					}
				else{
					dVal	= m_dScalaVal;
					dVal   -= m_dScalaMin;
					dVal   *= m_dScalaMul;
					}

				m_iSliderEnd	= (int)(dVal*m_dScalaSteps);
				m_uSliderLoop	= (m_iSliderEnd*SLIDER_LOOP)/m_iScalaLen;
				m_aStopTick[2]	= uTick+m_uSliderLoop;
				m_iSliderSwing	= rand()%100+m_iScalaLen/3;

				if(m_iSliderEnd+m_iSliderSwing>m_iScalaLen+SLIDER_START)
					{
					m_iSliderSwing = m_iScalaLen-m_iSliderEnd+SLIDER_START;
					}

				if(m_iSliderEnd-m_iSliderSwing<-SLIDER_START)
					{
					m_iSliderSwing = m_iSliderEnd+SLIDER_START;
					}
				}

			if(m_aRunMode[2]==2)							// Zielzeiger ist fertig
				{
				m_aSliderNow[iSide] = m_dScalaVal;
				m_aSliderPos[iSide] = m_iSliderEnd;
				}
			else{
				   uDiff = uTick-m_aStartTick[2];
				if(uDiff<m_uSliderLoop)
					{
					m_aSliderPos[2] = (m_iScalaLen*uDiff)/SLIDER_LOOP;
					}
				else if(uDiff-m_uSliderLoop<m_uSliderLoops*SLIDER_LOOP)
					{
					uDiff -=  m_uSliderLoop;
					dMul   =  uDiff;
					dMul  /= (m_uSliderLoops+0)*SLIDER_LOOP;
					dVal   = sin((double)uDiff/(double)SLIDER_LOOP*PI);
					dVal  *= 1.0-dMul;
					dVal  *= m_iSliderSwing;
					m_aSliderPos[2] = m_iSliderEnd+(int)dVal;
					}
				else{										// Ende erreicht
					iBit           |= 4;
					m_bStartFlag	= 0;
					m_aRunMode  [2]	= 2;
					m_aSliderNow[2] = m_dScalaVal;
					m_aSliderPos[2] = m_iSliderEnd;

					if(abs(m_aSliderPos[2]-m_aSliderPos[1])<abs(m_aSliderPos[2]-m_aSliderPos[0]))
						{
						if(m_bAutoCount)OnStarAdd2();
						m_iStarPos = m_aSliderPos[1]+5;
						m_iStarNum = 1;
						}

					if(abs(m_aSliderPos[2]-m_aSliderPos[1])>abs(m_aSliderPos[2]-m_aSliderPos[0]))
						{
						if(m_bAutoCount)OnStarAdd1();
						m_iStarPos = m_aSliderPos[0]+5;
						m_iStarNum = 0;
						}

					StartSound(m_pCling3,m_uCling3Len);
					}
				}
			}


		for(iSide=0;iSide<3;iSide++)						// Alte Slider prfen zeichnen
			{
			if(m_aSliderPos[iSide]==m_aSliderOld[iSide])continue;

			iSizeX	= m_aSlider[iSide].Width();
			iSizeY	= m_aSlider[iSide].Height();
			iBit   |= 1<<iSide;

			if(m_aSliderOld[iSide]>-1000)
				{
				iVal = m_aSliderOld[iSide]-iSizeX/2+m_iScalaPos;
				m_cBitmapWnd.InvalidateRect(iVal,iBottom+SLIDER_SCALA+2,iSizeX,iSizeY);
				pImage->Box(iVal,iBottom+SLIDER_SCALA+2,iSizeX,iSizeY,0);
				}
			}

		if(m_iStarPos!=m_iStarOld)
			{
			m_iStarOld	= m_iStarPos;
			iSizeX		= m_sStarImg3.Width();
			iSizeY		= m_sStarImg3.Height();
			iBit       |= 0x80;

			if(m_iStarOld>-1000)
				{
				iVal = m_iStarOld-iSizeX/2+m_iScalaPos;
				m_cBitmapWnd.InvalidateRect(iVal,iBottom+SLIDER_SCALA+38,iSizeX,iSizeY);
				pImage->Box(iVal,iBottom+SLIDER_SCALA+38,iSizeX,iSizeY,0);
				}
			}


		if(iBit)
			{
			for(iSide=0;iSide<3;iSide++)					// Texte lschen
				{
				if(!m_aSliderTxt[iSide])continue;
				pImage->Box(m_aSliderOff[iSide],m_iWndSizeY, m_aSliderTxt[iSide],-SLIDER_TEXT-2,0);
				m_cBitmapWnd.InvalidateRect(m_aSliderOff[iSide],m_iWndSizeY-SLIDER_TEXT-2,m_aSliderTxt[iSide],SLIDER_TEXT+2);
				}

			for(iSide=0;iSide<3;iSide++)					// Slider zeichnen
				{
				if(iSide==2 && m_aRunMode[2]==0)continue;
				if(m_bNoGame)continue;

				iSizeX	= m_aSlider[iSide].Width();
				iSizeY	= m_aSlider[iSide].Height();

				m_aSliderOld[iSide] = m_aSliderPos[iSide];
				iVal = m_aSliderPos[iSide]-iSizeX/2+m_iScalaPos;
				pImage->PutAlpha(m_aSlider[iSide],iVal,iBottom+SLIDER_SCALA+2);
				m_cBitmapWnd.InvalidateRect(iVal,iBottom+SLIDER_SCALA+2,iSizeX,iSizeY);
				}

			if(m_iStarPos>-1000)
				{
				iSizeX	= m_sStarImg3.Width();
				iSizeY	= m_sStarImg3.Height();
				iVal	= m_iStarOld-iSizeX/2+m_iScalaPos;
				pImage->PutAlpha(m_sStarImg3,iVal,iBottom+SLIDER_SCALA+38);
				m_cBitmapWnd.InvalidateRect(iVal,iBottom+SLIDER_SCALA+38,iSizeX,iSizeY);
				}

			pImage->SetFont(m_aSliderFnt);
			pImage->SetPixelFunction(TEXT_NONE,0,1);

			for(iSide=0;iSide<3;iSide++)					// Texte ausgeben
				{
				double	dVal;

				if(m_bNoGame)continue;

				if(iSide==2)
					{
					dVal  = m_dScalaVal*m_dScalaMul;
					}
				else if(m_bScalaLog)
					{
					dVal  = (double)m_aSliderPos[iSide]/m_dScalaSteps;
					dVal += log10(m_dScalaMin);
					dVal  = pow(10.0,dVal)*m_dScalaMul;
					}
				else{
					dVal  = m_dScalaMin*m_dScalaMul;
					dVal += (double)m_aSliderPos[iSide]/m_dScalaSteps;
					}

				iNum	= ValueText(cText,dVal,m_iScalaComa);
				iNum	= pImage->Print(0,BI_TETXSIZE,cText);

				if(iSide==0)
					{
					iVal			= 3;
					m_aSliderOff[0] = 0;
					}
				else if(iSide==1)
					{
					iVal			= m_iWndSizeX-3;
					m_aSliderOff[1] = m_iWndSizeX-3-iNum;
					}
				else if(m_aRunMode[2]==2)
					{
					iVal			= m_iSliderEnd+m_iScalaPos;
					m_aSliderOff[2] = m_iSliderEnd+m_iScalaPos-iNum/2;
					}
				else{
					m_aSliderTxt[2] = 0;
					continue;
					}

				pImage->SetAlign("\0\2\1"[iSide]);
				pImage->SetPixelFunction(TEXT_SMOTH,BGR(255,255,255));
				pImage->Print(iVal-1,m_iWndSizeY-SLIDER_TEXT-1,cText);
				pImage->Print(iVal+1,m_iWndSizeY-SLIDER_TEXT-1,cText);
				pImage->Print(iVal-1,m_iWndSizeY-SLIDER_TEXT+1,cText);
				pImage->Print(iVal+1,m_iWndSizeY-SLIDER_TEXT+1,cText);
				pImage->SetPixelFunction(TEXT_SMOTH,(m_iStarNum==iSide)? BGR(255,255,0):m_aSliderCol[iSide],0);
				pImage->Print(iVal,m_iWndSizeY-SLIDER_TEXT,cText);

				m_aSliderTxt[iSide] = iNum+8;
				m_aSliderNow[iSide] = dVal;
				m_cBitmapWnd.InvalidateRect(m_aSliderOff[iSide],m_iWndSizeY-SLIDER_TEXT-2,iNum,SLIDER_TEXT+2);
				}
			}


		m_bHgOk = TRUE;
		bLocked = FALSE;

		return;
		}

	CView::OnTimer(nIdEvent);
}

//*****************************************************************************
//*
//*		OnGotoNext
//*
//*****************************************************************************
//	Zum nchsten Spiels pringen
void CGamePriceView::OnGotoNext()
{
char		cUrl[256];
char		cTxt[256];
CString		sText;
unsigned	uTurn;
int			iOff;



	if(m_aRunMode[0] || m_aRunMode[1] || m_bStartFlag)	// Ist alle fertig
		{
		if(m_aRunMode[2]!=2)return;
		}


	m_iStarPos	  = -1000;
	m_iStarNum	  = -1;
	m_aRunMode[0] = 0;
	m_aRunMode[1] = 0;
	m_aRunMode[2] = 0;


	for(uTurn=0;;uTurn++)								// Suche das nchste Spiel
		{
		if(m_bResetFlag)
			{
			m_bResetFlag=0;
			}
		else{
			m_uGameIndex++;
			}

		sprintf(cUrl,"%s\\Game%03i\\Info.html",(LPCTSTR)m_sHtmlPath,m_uGameIndex);
		if(ExistFile(cUrl)==1)break;

		if(uTurn>50)
			{
			sText.Format("Die Datei %s konnte nicht gefunden werden !",cUrl);
			MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
			return;
			}
		}


	m_cHtmlWnd.Navigate2(cUrl);


	LoadMemory(cUrl,cTxt,sizeof(cTxt));					// Werte laden

	   iOff = strifind(cTxt,"<!--FIN");
	if(iOff>=0)
		{
		m_uGameIndex--;
		m_bNoGame=1;
		m_bHgOk  =0;
		return;
		}

	m_bNoGame = 0;

	   iOff = strifind(cTxt,"<!--MIN");
	if(iOff<0)
		{
		sText.Format("In %s konnten kein Minimalwert gefunden werden !",cUrl);
		MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	m_dScalaMin = atof(cTxt+iOff+7);

	   iOff = strifind(cTxt,"<!--MAX");
	if(iOff<0)
		{
		sText.Format("In %s konnten kein Maximalwert gefunden werden !",cUrl);
		MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	m_dScalaMax = atof(cTxt+iOff+7);

	   iOff = strifind(cTxt,"<!--VAL");
	if(iOff<0)
		{
		sText.Format("In %s konnten kein Lsungswert gefunden werden !",cUrl);
		MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	m_dScalaVal = atof(cTxt+iOff+7);

	if(m_dScalaVal<m_dScalaMin || m_dScalaVal>m_dScalaMax)
		{
		sText.Format("Der Lsungswert in %s ist nicht im Min/Maxbereich !",cUrl);
		MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	   iOff = strifind(cTxt,"<!--LOG");
	if(iOff<0)
		{
		sText.Format("In %s konnten kein Skalenmodus gefunden werden !",cUrl);
		MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	m_bScalaLog	= atoi(cTxt+iOff+7);
	m_bStartFlag= 1;
	m_bHgOk		= 0;


	AfxGetMainWnd()->SetWindowText(cUrl);
	RedrawWindow();

	if(m_bSingleMode)									// Verzgerter gemeinsamer Start
		{
		m_uStartTicker = 1000/TIMER_MS;
		}

	m_uTimeRest = (m_uTimeLimith*1000)/TIMER_MS;

}


//*****************************************************************************
//*
//*		OnNextGame
//*
//*****************************************************************************
void CGamePriceView::OnNextGame()
{
int			iNum;
CValueDlg	sDlg;


	sDlg.SetValue(m_uGameIndex+1);
	sDlg.SetTitle("Nchstes Spiel");
	sDlg.SetTextTitle("Bitte hier die Spielnummer eingeben :");
	if(sDlg.DoModal()!=IDOK)return;

	iNum = sDlg.GetValue();

	if(iNum>=0 && iNum<1000 && (iNum^m_uGameIndex))
		{
		m_uGameIndex = iNum-1;
		m_bResetFlag = 0;
		Reset();
		OnGotoNext();
		}

}

//*****************************************************************************
//*
//*		OnHtmlFormat
//*
//*****************************************************************************
void CGamePriceView::OnHtmlFormat()
{
CDialog	sDlg(IDD_HTMLFORMAT);


	sDlg.DoModal();


}

