//*****************************************************************************
//*
//*
//*		GamePriceView.h
//*
//*
//*****************************************************************************
#ifndef		AFX_GAMEPRICEVIEW_H__77743167_0938_40FE_A1F4_64E3F5A18C4B__INCLUDED_
#define		AFX_GAMEPRICEVIEW_H__77743167_0938_40FE_A1F4_64E3F5A18C4B__INCLUDED_

#if _MSC_VER > 1000
#pragma		once
#endif

#define 	MAX_PT			32
#define 	MAX_POLY		32
#define 	MAX_TICKS		128

//*****************************************************************************
//*
//*		Klasse CGamePriceView
//*
//*****************************************************************************
class CGamePriceView : public CView
{
protected:

	CGamePriceView();
	DECLARE_DYNCREATE(CGamePriceView)

public:

	CGamePriceDoc* GetDocument();

	void		 SetZoom(int iZoom);
	void		 UseImage(int iMode);
	void		 Stop (unsigned uPlace,unsigned uTick);
	void		 Start(unsigned uPlace,unsigned uTick);
	void		 SetStartPath(LPCTSTR pPath);
	void		 Reset();


	//{{AFX_VIRTUAL(CGamePriceView)
public:
	virtual void OnDraw(CDC* pDC);								// berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT &sCreate);
protected:
	//}}AFX_VIRTUAL

public:
	virtual ~CGamePriceView();
	#ifdef		_DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext &sDc) const;
	#endif

protected:

	double			m_dScalaSteps;									// Auflsung fr Werte je Abschnitt
	double			m_dScalaVal;									// Werte fr die Skala
	double			m_dScalaMin;									// Werte fr die Skala
	double			m_dScalaMax;									//			*
	double			m_dScalaMul;									// Kommaausglecih fr Skala
	BOOL			m_bScalaLog;									// Logarithmische Skala
	BOOL			m_bScalaCol;									// Mehrfarbige Skala
	int				m_iScalaLen;									// Skalenlnge in Pixel
	int				m_iScalaPos;									// Skalen-X-Position in Pixel
	int				m_iScalaComa;									// Kommastellen fr Skala

	BitmapImage		m_aSlider[3];									// Bilder fr Slider
	unsigned		m_aSliderCol[3];								// Farben fr Slider
	int				m_aSliderPos[3];								// Positionen der Slider
	int				m_aSliderOld[3];								// Alte Positionen der Slider
	int				m_aSliderTxt[3];								// Breite des Textes
	int				m_aSliderOff[3];								// Offset des Textes
	double			m_aSliderNow[3];								// Aktueller Wert
	UINT			m_aStartTick[3];								// Startzeit
	UINT			m_aStopTick[3];									// Stopzeit
	UINT			m_aRunMode[3];									// 0=Warten 1=Gestartet 2=Fertig
	BOOL			m_bSingleMode;									// Jeder startet einzeln (0=einzeln 1=gemeinsam)
	BOOL			m_bAutoCount;									// Automatisch Punkte zhlen
	BOOL			m_bSameSide;									// Auf gleicher Seite starten
	CString			m_sHtmlPath;									// Pfad fr HTML-Fragen
	CString			m_sHtmlOrig;									// Original Pfad fr HTML-Fragen
	CHtmlCtrl		m_cHtmlWnd;										// HTML Fenster
	UINT			m_uGameIndex;									// Aktuelle Spielnummer
	UINT			m_uStartTicker;									// Verzgerter gemeinsamer Start
	UINT			m_uTimeLimith;									// Zeitlimit in Sekunden
	UINT			m_uTimeRest;									// Rest vom Zeitlimit

	UINT			m_uSliderLoops;									// Nachwackeln des Zerigers
	UINT			m_uSliderLoop;									// Tick bis Loop
	int				m_iSliderEnd;									// Endposition fr den Zeiger
	int				m_iSliderSwing;									// Auschwing bereich
	int				m_iStarPos;										// Sternposition
	int				m_iStarOld;										// Alte Sternposition
	int				m_iStarNum;										// Wer liegt richtig

	BYTE			m_aStars[64];
	BYTE			m_aPoints[2];
	CBitmapWnd		m_cBitmapWnd;
	static DWORD	m_aHgColors[];
	BitmapImage		m_sStarImg1;
	BitmapImage		m_sStarImg2;
	BitmapImage		m_sStarImg3;
	BitmapImage		m_sStarImg;
	int				m_iImageDrawX;
	int				m_iImageDrawY;
	int				m_iRotorDrawX;
	int				m_iRotorDrawY;
	int				m_iDrawAddX;
	int				m_iDrawAddY;
	CRect			m_sWndRect;
	BOOL			m_bResetFlag;									// Gab es eine Reset
	BOOL			m_bStartFlag;									// Spiel gestartet
	BOOL			m_bNoGame;										// Keine Spiele mehr
	BOOL			m_bHgOk;

	double			m_dLevel;
	double			m_dTimeLen;
	DWORD			m_uTurnMax;
	int				m_iPhiStart;

	static DWORD	m_uLastCling;
	DWORD			m_uLastTick;
	DWORD			m_uLastZoom;
	DWORD			m_uDownTick;
	DWORD			m_uDeltaTick;
	DWORD			m_aLastErr[2];
	DWORD			m_aLockKey[2];
	int				m_iWndSizeX;
	int				m_iWndSizeY;
	int				m_iStarSize;
	int				m_iStarRows;
	int				m_iStarMax;
	int				m_iStarX;
	int				m_iStarY;
	int				m_iZoom;
	int volatile	m_iStop;
	int volatile	m_iDone;
	int volatile	m_iPort;
	int volatile	m_iAudioRun;
	int volatile	m_iAudioStop;
	static UINT		m_aSndTickStart[MAX_TICKS];
	static UINT		m_aSndTickStop [MAX_TICKS];
	static UINT		m_aSndTickMul  [MAX_TICKS];
	static UINT		m_uSndTickCount;
	static UINT		m_uAudioType;
	static UINT		m_uAudioPos;
	static UINT		m_uCling1Len;
	static HRSRC	m_hCling1Src;
	static HGLOBAL	m_hCling1Hg;
	static short   *m_pCling1;
	static UINT		m_uCling2Len;
	static HRSRC	m_hCling2Src;
	static HGLOBAL	m_hCling2Hg;
	static short   *m_pCling2;
	static UINT		m_uCling3Len;
	static HRSRC	m_hCling3Src;
	static HGLOBAL	m_hCling3Hg;
	static short   *m_pCling3;
	static UINT		m_uTimerLen;
	static HRSRC	m_hTimerSrc;
	static HGLOBAL	m_hTimerHg;
	static short   *m_pTimer;
	static UINT		m_uSweepLen;
	static HRSRC	m_hSweepSrc;
	static HGLOBAL	m_hSweepHg;
	static short   *m_pSweep;
	static UINT		m_uErrorLen;
	static HRSRC	m_hErrorSrc;
	static HGLOBAL	m_hErrorHg;
	static short   *m_pError;
	static UINT		m_uTickLen;
	static HRSRC	m_hTickSrc;
	static HGLOBAL	m_hTickHg;
	static short   *m_pTick;
	static short   *m_aPlay[4];
	static UINT		m_aPlayLen[4];
	static BYTE		m_aScalaFont[];
	static BYTE		m_aSliderFnt[];
	static BYTE		m_aSliderImg[];
	static BYTE		m_aPointerImg[];

protected:
	//{{AFX_MSG(CGamePriceView)
	afx_msg int  OnCreate (LPCREATESTRUCT pCreateStruct);
	afx_msg void OnSize   (UINT nType,int iSizeX,int iSizeY);
	afx_msg void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
	afx_msg void OnKeyUp  (UINT nChar,UINT nRepCnt,UINT nFlags);
	afx_msg void OnTimer  (UINT_PTR nIDEvent);
	afx_msg void OnUseImageAUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageBUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageCUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageDUI(CCmdUI *pCmdUI);
	afx_msg void OnHtmlFormat();
	afx_msg void OnSelComPort();
	afx_msg void OnUseImageA();
	afx_msg void OnUseImageB();
	afx_msg void OnUseImageC();
	afx_msg void OnUseImageD();
	afx_msg void OnNextGame();
	afx_msg void OnGotoNext();
	afx_msg void OnDrawMove();
	afx_msg void OnDrawEdit();
	afx_msg void OnStarAdd1();
	afx_msg void OnStarAdd2();
	afx_msg void OnStarSub1();
	afx_msg void OnStarSub2();
	afx_msg void OnSettings();
	afx_msg void OnDestroy();
	afx_msg void OnStop1();
	afx_msg void OnStop2();
	afx_msg void OnStart();
	afx_msg void OnReset();
	//}}AFX_MSG

	virtual void OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint);
	void		 UpdateImage(UINT uNumber,COLORREF uColor);

	void		 SelectStar(int iStar);
	void		 StartSound(LPCTSTR pSound);
	void		 StartSound(short *pData,unsigned uLen);

	static  UINT ScaleColor(int iPos,int iMax);
	static  UINT ValueText(char *pText,double dVal,int iComa=0);

	static	DWORD WINAPI AudioThread(LPVOID pParam);
	static	DWORD WINAPI WaveThread (LPVOID pParam);
	static	DWORD WINAPI ComThread  (LPVOID pParam);

	DECLARE_MESSAGE_MAP()


};


//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
#ifndef		_DEBUG
inline CGamePriceDoc *CGamePriceView::GetDocument(){return (CGamePriceDoc*)m_pDocument; }
#endif

#endif

